﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Syncfusion.SfChart.XForms;
using Native = Com.Syncfusion.Charts;
using Syncfusion.SfChart.XForms.Droid;
using Xamarin.Forms.Platform.Android;
using Xamarin.Forms;
using Android.Graphics;
using System.Reflection;
using System.Collections.ObjectModel;

namespace Chart_GettingStarted.Droid
{
    public class CustomSelectionBehavior : Native.ChartSelectionBehavior 
    {
        public Xamarin.Forms.ListView ListView { get; set; }
        public Syncfusion.SfChart.XForms.SfChart FormsChart { get; set; }

        public CustomSelectionBehavior(Syncfusion.SfChart.XForms.SfChart xFormschart, Xamarin.Forms.ListView listView)
        {
            ListView = listView;
            FormsChart = xFormschart;
        }

        protected override void OnSelectionChanged(Native.ChartSelectionEvent chartSelectionEvent)
        {
            base.OnSelectionChanged(chartSelectionEvent);

            ViewModel chartBindingContext = FormsChart.BindingContext as ViewModel;

            chartBindingContext.GroupedYValues = new ObservableCollection<Model>();

            var segments = chartSelectionEvent.SelectedSeries.Segments;

            if (chartSelectionEvent.SelectedDataPointIndex == -1)
            {
                chartBindingContext.GroupedYValues.Clear();
                return;
            }

            Native.PieSegment selectedSegment = segments[chartSelectionEvent.SelectedDataPointIndex] as Native.PieSegment;

            if (chartSelectionEvent.SelectedDataPointIndex == segments.Count - 1)
            {
                PropertyInfo dataPointInfo = typeof(Native.CircularSeries).GetProperty("GroupedData", BindingFlags.NonPublic | BindingFlags.Instance);
                List<object> groupedDataPoints = dataPointInfo.GetValue(chartSelectionEvent.SelectedSeries, null) as List<object>;

                for (int i = 0; i < groupedDataPoints.Count; i++)
                {
                    chartBindingContext.GroupedYValues.Add(new Model((groupedDataPoints[i] as Model).XValue, (groupedDataPoints[i] as Model).YValue));
                }
            }
            else
            {
                int selectedDataPointIndex = 0;
                var itemsource = chartSelectionEvent.SelectedSeries.ItemsSource;

                foreach (Model item in itemsource)
                {
                    if ((item as Model).YValue == selectedSegment.YValue)
                    {
                        selectedDataPointIndex = (itemsource as ObservableCollection<Model>).IndexOf(item);
                        break;
                    }
                }

                chartBindingContext.GroupedYValues.Add(new Model((itemsource as ObservableCollection<Model>)[selectedDataPointIndex].XValue, selectedSegment.YValue));
            }

            if (ListView != null)
            {
                ListView.ItemsSource = null;
                ListView.ItemsSource = chartBindingContext.GroupedYValues;
            }
        }
    }
}
