﻿using System;

using Android.App;
using Android.Content.PM;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Com.Syncfusion.Charts;
using Syncfusion.SfChart.XForms.Droid;

namespace Chart_GettingStarted.Droid
{
    [Activity(Label = "Chart_GettingStarted", Icon = "@drawable/icon", Theme = "@style/MainTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation)]
    public class MainActivity : global::Xamarin.Forms.Platform.Android.FormsAppCompatActivity
    {
        protected override void OnCreate(Bundle bundle)
        {
            TabLayoutResource = Resource.Layout.Tabbar;
            ToolbarResource = Resource.Layout.Toolbar;

            base.OnCreate(bundle);

            global::Xamarin.Forms.Forms.Init(this, bundle);
            Xamarin.Forms.Forms.ViewInitialized += Forms_ViewInitialized;
            LoadApplication(new App());

        }
   
        void Forms_ViewInitialized(object sender, Xamarin.Forms.ViewInitializedEventArgs e)
        {
            Xamarin.Forms.ListView listview = null;

            if (e.View is Xamarin.Forms.ListView)
            {
                listview = e.View as Xamarin.Forms.ListView;
            }

            if (e.NativeView is SfChart)
            {
                SfChart chart = e.NativeView as SfChart;
                var formsChart = e.View as Syncfusion.SfChart.XForms.SfChart;

                for (int i = 0; i < formsChart.ChartBehaviors.Count; i++)
                {
                    if (formsChart.ChartBehaviors[i] is Syncfusion.SfChart.XForms.ChartSelectionBehavior)
                    {
                        var formsTrackball = formsChart.ChartBehaviors[i] as Syncfusion.SfChart.XForms.ChartSelectionBehavior;
                        CustomSelectionBehavior customTrackball = new CustomSelectionBehavior(formsChart, listview);
                        var properties = SfChartRenderer.GetPropertiesChanged(typeof(Syncfusion.SfChart.XForms.ChartSelectionBehavior), formsTrackball);

                        chart.Behaviors.RemoveAt(i);
                        chart.Behaviors.Insert(i, customTrackball);
                    }
                }
            }
        }

    }
}

