﻿using System;
using System.Collections.Generic;
using System.Linq;

using Foundation;
using UIKit;
using Syncfusion.SfChart.XForms.iOS.Renderers;
using Syncfusion.SfChart.iOS;
using Syncfusion.SfChart.XForms.iOS;

namespace Chart_GettingStarted.iOS
{
    // The UIApplicationDelegate for the application. This class is responsible for launching the 
    // User Interface of the application, as well as listening (and optionally responding) to 
    // application events from iOS.
    [Register("AppDelegate")]
    public partial class AppDelegate : global::Xamarin.Forms.Platform.iOS.FormsApplicationDelegate
    {
        //
        // This method is invoked when the application has loaded and is ready to run. In this 
        // method you should instantiate the window, load the UI into it and then make the window
        // visible.
        //
        // You have 17 seconds to return from this method, or iOS will terminate your application.
        //
        public override bool FinishedLaunching(UIApplication app, NSDictionary options)
        {
            global::Xamarin.Forms.Forms.Init();
            LoadApplication(new App());
            Xamarin.Forms.Forms.ViewInitialized += Forms_ViewInitialized;

            SfChartRenderer.Init();
            return base.FinishedLaunching(app, options);
        }

        void Forms_ViewInitialized(object sender, Xamarin.Forms.ViewInitializedEventArgs e)
        {
            Xamarin.Forms.ListView listview = null;

            if (e.View is Xamarin.Forms.ListView)
            {
                listview = e.View as Xamarin.Forms.ListView;
            }

            if (e.NativeView is SFChart)
            {
                SFChart chart = e.NativeView as SFChart;

                var formsChart = e.View as Syncfusion.SfChart.XForms.SfChart;

                for (int i = 0; i < formsChart.ChartBehaviors.Count; i++)
                {
                    if (formsChart.ChartBehaviors[i] is Syncfusion.SfChart.XForms.ChartSelectionBehavior)
                    {
                        var formsTrackball = formsChart.ChartBehaviors[i] as Syncfusion.SfChart.XForms.ChartSelectionBehavior;
                        CustomSelectionBehavior customTrackball = new CustomSelectionBehavior(formsChart, listview);
                        var properties = SfChartRenderer.GetPropertiesChanged(typeof(Syncfusion.SfChart.XForms.ChartSelectionBehavior), formsTrackball);

                        chart.Behaviors.RemoveAt(i);
                        chart.Behaviors.Insert(i, customTrackball);
                    }
                }
            }
        }
    }
}
