﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Chart_GettingStarted
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class Sample : ContentPage
	{
		public Sample ()
		{
            InitializeComponent();
        }
    }

    public class ViewModel: INotifyPropertyChanged
    {
        public ObservableCollection<Model> Data { get; set; }

        private ObservableCollection<Model> groupedYValues;

        public ObservableCollection<Model> GroupedYValues
        {
            get { return groupedYValues; }
            set
            {
                if (groupedYValues == value) return;
                groupedYValues = value;
                RaisePropertyChanged("GroupedYValues");
            }
        }

        public ViewModel()
        {
            Data = new ObservableCollection<Model>()
            {
                new Model( "Tony", 2),
                new Model("Steve", 4),
                new Model("Nick", 50)
            };

            GroupedYValues = new ObservableCollection<Model>()
            {
            };
        }

        public event PropertyChangedEventHandler PropertyChanged;

        void RaisePropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

    public class Model
    {
        public string XValue { get; set; }
        public double YValue { get; set; }

        public Model(string xVal, double yVal)
        {
            XValue = xVal;
            YValue = yVal;
        }
    }

    //public class DataMarkerConverter : IValueConverter
    //{
    //    public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
    //    {
    //        var groupedData = new List<object>();
    //        var groupedXData = new List<object>();

    //         if (value == null)
    //            return value;

    //        if (value is List<Object>)
    //        {
    //            var groupedSegment = value as List<object>;

    //            for (int i = 0; i < groupedSegment.Count; i++)
    //            {
    //                groupedData.Add((groupedSegment[i] as Model).YValue);
    //                groupedXData.Add((groupedSegment[i] as Model).XValue);
    //            }

    //            return string.Format("{0} : {1} \n {2} : {3} \n {4} : {5}", groupedXData[0], groupedData[0], groupedXData[1], groupedData[1], groupedXData[2], groupedData[2]);
    //        }
    //        else
    //        {
    //            return string.Format("{0} : {1}", (value as Model).XValue, (value as Model).YValue);
    //        }
    //    }

    //    public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
    //    {
    //        return value;
    //    }
    //}
}